diff --git a/test/unit/claude_launcher_test.rb b/test/unit/claude_launcher_test.rb
index 1d6b2589..583c248a 100644
--- a/test/unit/claude_launcher_test.rb
+++ b/test/unit/claude_launcher_test.rb
@@ -124,6 +124,7 @@ class ClaudeLauncherTest < Minitest::Test
       runner.define_singleton_method(:start_detached) { |command:| @command = command }
       runner.define_singleton_method(:kill_session) { }
       captured_flags = nil
+      reset_calls = 0
       cfg = {
         "claude" => {
           "permission_mode" => "bypassPermissions",
@@ -134,7 +135,11 @@ class ClaudeLauncherTest < Minitest::Test
 
       with_replaced_singleton_method(Hive::ClaudeLauncher, :build_runner, ->(**) { runner }) do
         with_replaced_singleton_method(Hive::ClaudeLauncher, :preflight!, ->(*) { }) do
-          with_replaced_singleton_method(Hive::ClaudeLauncher, :reset_signal_files, ->(*) { }) do
+          original_reset = Hive::ClaudeLauncher.method(:reset_signal_files)
+          with_replaced_singleton_method(Hive::ClaudeLauncher, :reset_signal_files, lambda { |reset_task|
+            reset_calls += 1
+            original_reset.call(reset_task)
+          }) do
             with_replaced_singleton_method(Hive::StopHookInstaller, :install, ->(**) { [] }) do
               with_replaced_singleton_method(Hive::ClaudeLauncher, :wrapper_command, lambda { |**kwargs|
                 captured_flags = kwargs.fetch(:cli_flags)
@@ -145,14 +150,15 @@ class ClaudeLauncherTest < Minitest::Test
                     with_replaced_singleton_method(Hive::ClaudeLauncher, :prepare_claude_session!, ->(*) { }) do
                       with_replaced_singleton_method(Hive::ClaudeLauncher, :shutdown_claude, ->(*) { }) do
                         with_replaced_singleton_method(Hive::ClaudeLauncher, :sweep_orphan_processes, ->(*) { }) do
-                          with_replaced_singleton_method(Hive::ClaudeLauncher, :cleanup_done, ->(*) { }) do
-                            Hive::ClaudeLauncher.with_shared_session(
-                              task: task,
-                              cfg: cfg,
-                              session_name: "hive-test-session",
-                              cwd: task.folder,
-                              add_dirs: []
-                            ) { |_handle| }
+                          Hive::ClaudeLauncher.with_shared_session(
+                            task: task,
+                            cfg: cfg,
+                            session_name: "hive-test-session",
+                            cwd: task.folder,
+                            add_dirs: []
+                          ) do |_handle|
+                            File.write(Hive::ClaudeLauncher.done_path(task), "done")
+                            File.write(Hive::ClaudeLauncher.result_path(task), "{}")
                           end
                         end
                       end
@@ -166,6 +172,9 @@ class ClaudeLauncherTest < Minitest::Test
       end
 
       assert_equal %w[--model sonnet --effort medium], captured_flags
+      assert_equal 2, reset_calls
+      refute_path_exists Hive::ClaudeLauncher.done_path(task)
+      refute_path_exists Hive::ClaudeLauncher.result_path(task)
     end
   end
 
@@ -1066,6 +1075,7 @@ class ClaudeLauncherTest < Minitest::Test
         def capture_pane_tail(bytes:) = tail
       end.new("")
       missing_output = File.join(task.folder, "missing.md")
+      File.write(Hive::ClaudeLauncher.result_path(task), "{}")
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
 
       done_result = Hive::ClaudeLauncher.wait_for_status(
@@ -1224,6 +1234,286 @@ class ClaudeLauncherTest < Minitest::Test
       timeout = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "ci")
       assert_equal :timeout, timeout.fetch(:status)
       assert_match(/stop hook did not signal/, timeout.fetch(:error_message))
+      evidence = timeout.fetch(:completion_evidence)
+      assert_equal false, evidence.fetch(:normal_completion)
+      assert_nil evidence.fetch(:session_alive)
+      assert_equal false, evidence.fetch(:tmux_readable)
+      assert_equal Hive::ClaudeLauncher.done_path(task),
+                   evidence.fetch(:expected_signal_paths).fetch(:sentinel)
+      assert_equal Hive::ClaudeLauncher.result_path(task),
+                   evidence.fetch(:expected_signal_paths).fetch(:result)
+    end
+  end
+
+  def test_wait_for_done_signal_records_busy_to_idle_completion_without_succeeding
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :tails) do
+        def session_exists? = true
+
+        def capture_pane_tail(bytes:)
+          tails.length > 1 ? tails.shift : tails.first
+        end
+      end.new(
+        "review-fix-session",
+        [
+          "Claude Code v2.1.179\nWorking on fixes...\n",
+          "Claude Code v2.1.179\n────────\n❯\n"
+        ]
+      )
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.001",
+        "HIVE_CLAUDE_TMUX_STOP_SIGNAL_GRACE_SEC" => "0.005"
+      ) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "review-fix")
+        evidence = result.fetch(:completion_evidence)
+
+        assert_equal :timeout, result.fetch(:status)
+        assert_equal :busy_to_idle, evidence.fetch(:reason)
+        assert_equal true, evidence.fetch(:normal_completion)
+        assert_equal true, evidence.fetch(:work_started)
+        assert_equal true, evidence.fetch(:pane_idle)
+        assert_equal true, evidence.fetch(:session_alive)
+        assert_equal true, evidence.fetch(:tmux_readable)
+        assert_equal :tmux, evidence.fetch(:launch_mode)
+        assert_nil evidence.fetch(:session_error)
+        assert_equal "review-fix-session", evidence.fetch(:session_name)
+        assert_nil evidence.fetch(:exit_code)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_honors_late_explicit_error_after_busy_to_idle
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :task, :captures) do
+        def session_exists? = true
+
+        def capture_pane_tail(bytes:)
+          self.captures += 1
+          if captures >= 3
+            File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "error"))
+            File.write(Hive::ClaudeLauncher.done_path(task), "done")
+          end
+          captures == 1 ? "Claude Code\nworking" : "Claude Code\n────────\n❯\n"
+        end
+      end.new("late-error", task, 0)
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.001",
+        "HIVE_CLAUDE_TMUX_STOP_SIGNAL_GRACE_SEC" => "0.05"
+      ) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "review-fix")
+
+        assert_equal :error, result.fetch(:status)
+        assert_match(/reported :error via result\.json/, result.fetch(:error_message))
+        refute result.key?(:completion_evidence)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_polls_result_before_sentinel_race
+    with_tmp_task do |task|
+      runner = Struct.new(:name, :task, :captures) do
+        def session_exists? = true
+
+        def capture_pane_tail(bytes:)
+          self.captures += 1
+          File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "ok")) if captures == 2
+          File.write(Hive::ClaudeLauncher.done_path(task), "done") if captures >= 3
+          captures == 1 ? "Claude Code\nworking" : "Claude Code\n────────\n❯\n"
+        end
+      end.new("result-before-sentinel", task, 0)
+
+      with_env(
+        "HIVE_CLAUDE_TMUX_POLL_INTERVAL_SEC" => "0.001",
+        "HIVE_CLAUDE_TMUX_STOP_SIGNAL_GRACE_SEC" => "0.05"
+      ) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "review-fix")
+
+        assert_equal :ok, result.fetch(:status)
+        assert_equal "review-fix", result.fetch(:log_label)
+        refute result.key?(:completion_evidence)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_does_not_treat_cold_idle_as_turn_completion
+    with_tmp_task do |task|
+      runner = Struct.new(:name) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = "Claude Code v2.1.179\n────────\n❯\n"
+      end.new("cold-idle")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "review-fix")
+      evidence = result.fetch(:completion_evidence)
+
+      assert_equal :timeout, result.fetch(:status)
+      assert_equal :deadline, evidence.fetch(:reason)
+      assert_equal false, evidence.fetch(:normal_completion)
+      assert_equal false, evidence.fetch(:work_started)
+      assert_equal true, evidence.fetch(:pane_idle)
+    end
+  end
+
+  def test_wait_for_done_signal_records_busy_pane_at_deadline
+    with_tmp_task do |task|
+      runner = Struct.new(:name) do
+        def session_exists? = true
+        def capture_pane_tail(bytes:) = "Claude Code v2.1.179\nStill applying fixes...\n"
+      end.new("busy-session")
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 0, "review-fix")
+      evidence = result.fetch(:completion_evidence)
+
+      assert_equal :timeout, result.fetch(:status)
+      assert_equal :deadline, evidence.fetch(:reason)
+      assert_equal false, evidence.fetch(:normal_completion)
+      assert_equal true, evidence.fetch(:work_started)
+      assert_equal false, evidence.fetch(:pane_idle)
+    end
+  end
+
+  def test_wait_for_done_signal_records_dead_and_unreadable_sessions
+    with_tmp_task do |task|
+      dead_runner = Struct.new(:name) do
+        def session_exists? = false
+        def capture_pane_tail(bytes:) = "Claude Code\nworking"
+      end.new("dead-session")
+
+      dead = Hive::ClaudeLauncher.wait_for_done_signal(task, dead_runner, 10, "review-fix")
+      dead_evidence = dead.fetch(:completion_evidence)
+      assert_equal :timeout, dead.fetch(:status)
+      assert_equal :session_terminated, dead_evidence.fetch(:reason)
+      assert_equal false, dead_evidence.fetch(:session_alive)
+      assert_equal false, dead_evidence.fetch(:normal_completion)
+    end
+
+    with_tmp_task do |task|
+      unreadable_runner = Struct.new(:name) do
+        def session_exists? = true
+
+        def capture_pane_tail(bytes:)
+          raise Hive::TmuxError, "pane vanished"
+        end
+      end.new("unreadable-session")
+
+      unreadable = Hive::ClaudeLauncher.wait_for_done_signal(task, unreadable_runner, 0, "review-fix")
+      evidence = unreadable.fetch(:completion_evidence)
+      assert_equal :timeout, unreadable.fetch(:status)
+      assert_equal :pane_unreadable, evidence.fetch(:reason)
+      assert_equal true, evidence.fetch(:session_alive)
+      assert_equal false, evidence.fetch(:tmux_readable)
+      assert_equal "pane vanished", evidence.fetch(:session_error)
+      assert_nil evidence.fetch(:pane_idle)
+      assert_equal false, evidence.fetch(:normal_completion)
+    end
+  end
+
+  def test_wait_for_done_signal_records_liveness_probe_errors_and_missing_capabilities
+    with_tmp_task do |task|
+      broken_runner = Struct.new(:name) do
+        def session_exists?
+          raise Hive::TmuxError, "server unavailable"
+        end
+
+        def capture_pane_tail(bytes:) = "Claude Code\nworking"
+      end.new("broken-session")
+
+      broken = Hive::ClaudeLauncher.wait_for_done_signal(task, broken_runner, 10, "review-fix")
+      evidence = broken.fetch(:completion_evidence)
+      assert_equal :session_unreadable, evidence.fetch(:reason)
+      assert_nil evidence.fetch(:session_alive)
+      assert_equal "server unavailable", evidence.fetch(:session_error)
+      assert_equal false, evidence.fetch(:normal_completion)
+    end
+
+    with_tmp_task do |task|
+      missing = Hive::ClaudeLauncher.wait_for_done_signal(task, Object.new, 0, "review-fix")
+      evidence = missing.fetch(:completion_evidence)
+      assert_equal :deadline, evidence.fetch(:reason)
+      assert_nil evidence.fetch(:session_alive)
+      assert_equal false, evidence.fetch(:tmux_readable)
+      assert_equal false, evidence.fetch(:normal_completion)
+    end
+  end
+
+  def test_wait_for_done_signal_records_dead_pid_as_crash_evidence
+    with_tmp_task do |task|
+      File.write(File.join(task.folder, ".lock"), YAML.dump("claude_pid" => 999_999_999))
+      runner = Struct.new(:name, :tails) do
+        def session_exists? = true
+
+        def capture_pane_tail(bytes:)
+          tails.length > 1 ? tails.shift : tails.first
+        end
+      end.new(
+        "dead-pid",
+        [ "Claude Code\nworking", "Claude Code\n────────\n❯\n" ]
+      )
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, ->(_seconds) { }) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "review-fix")
+        evidence = result.fetch(:completion_evidence)
+        assert_equal 999_999_999, evidence.fetch(:pid)
+        assert_equal :dead, evidence.fetch(:process_state)
+        assert_equal false, evidence.fetch(:normal_completion)
+      end
+    end
+  end
+
+  def test_wait_for_done_signal_rejects_missing_or_malformed_result_payload
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+
+      missing = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "review-fix")
+      assert_equal :error, missing.fetch(:status)
+      assert_match(/result\.json missing or malformed/, missing.fetch(:error_message))
+
+      File.write(Hive::ClaudeLauncher.result_path(task), "{")
+      malformed = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "review-fix")
+      assert_equal :error, malformed.fetch(:status)
+      assert_match(/result\.json missing or malformed/, malformed.fetch(:error_message))
+    end
+  end
+
+  def test_wait_for_done_signal_rejects_empty_stdin_forensic_payload
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(
+        Hive::ClaudeLauncher.result_path(task),
+        JSON.generate("hive_stop_hook" => "empty_stdin")
+      )
+
+      result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 0, "review-fix")
+
+      assert_equal :error, result.fetch(:status)
+      assert_match(/reported :error via result\.json/, result.fetch(:error_message))
+    end
+  end
+
+  def test_busy_to_idle_result_evidence_cannot_claim_normal_completion
+    with_tmp_task do |task|
+      File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "failed"))
+      runner = Struct.new(:name, :tails) do
+        def session_exists? = true
+
+        def capture_pane_tail(bytes:)
+          tails.length > 1 ? tails.shift : tails.first
+        end
+      end.new(
+        "result-without-sentinel",
+        [ "Claude Code\nworking", "Claude Code\n────────\n❯\n" ]
+      )
+
+      with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, ->(_seconds) { }) do
+        result = Hive::ClaudeLauncher.wait_for_done_signal(task, runner, 10, "review-fix")
+        evidence = result.fetch(:completion_evidence)
+
+        assert_equal :timeout, result.fetch(:status)
+        assert_equal true, evidence.fetch(:result_present)
+        assert_equal false, evidence.fetch(:sentinel_present)
+        assert_equal false, evidence.fetch(:normal_completion)
+      end
     end
   end
 
@@ -1269,6 +1559,7 @@ class ClaudeLauncherTest < Minitest::Test
 
     with_tmp_task do |task|
       File.write(Hive::ClaudeLauncher.done_path(task), "done")
+      File.write(Hive::ClaudeLauncher.result_path(task), "{}")
       runner = Struct.new(:tail) do
         def capture_pane_tail(bytes:) = tail
       end.new(quoted_pane)
@@ -1296,6 +1587,12 @@ class ClaudeLauncherTest < Minitest::Test
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate("status" => "cancelled"))
       assert_equal :cancelled, Hive::ClaudeLauncher.read_result_json_status(task)
 
+      File.write(
+        Hive::ClaudeLauncher.result_path(task),
+        JSON.generate("hive_stop_hook" => "empty_stdin")
+      )
+      assert_equal :error, Hive::ClaudeLauncher.read_result_json_status(task)
+
       File.write(Hive::ClaudeLauncher.result_path(task), JSON.generate([ "not", "a", "hash" ]))
       assert_nil Hive::ClaudeLauncher.read_result_json_status(task)
 
diff --git a/test/unit/current_main_coverage_gap_test.rb b/test/unit/current_main_coverage_gap_test.rb
index 1c17f2a6..72cd0c7c 100644
--- a/test/unit/current_main_coverage_gap_test.rb
+++ b/test/unit/current_main_coverage_gap_test.rb
@@ -134,7 +134,11 @@ class CurrentMainCoverageGapTest < Minitest::Test
             original_exist.call(path)
           end
         }) do
-          with_replaced_singleton_method(Hive::ClaudeLauncher, :read_result_json_status, ->(_task) { :ok }) do
+          with_replaced_singleton_method(
+            Hive::ClaudeLauncher,
+            :read_result_json_payload,
+            ->(_task) { { "status" => "ok" } }
+          ) do
             with_replaced_singleton_method(Hive::ClaudeLauncher, :sleep, ->(seconds) { sleeps << seconds }) do
               result = Hive::ClaudeLauncher.wait_for_done_signal(task, nil, 5, "review")
 
diff --git a/test/unit/events_test.rb b/test/unit/events_test.rb
index 9d5471ad..80f21be8 100644
--- a/test/unit/events_test.rb
+++ b/test/unit/events_test.rb
@@ -39,6 +39,75 @@ class EventsTest < Minitest::Test
     end
   end
 
+  def test_completion_fallback_event_is_non_terminal_and_does_not_open_an_agent
+    with_tmp_dir do |dir|
+      record = Hive::Events.emit(
+        task_folder: dir,
+        slug: "fallback-test",
+        stage: "6-review",
+        event_type: :claude_completion_fallback,
+        message: "level=warn phase=fix pass=1 reason=missing_stop_signal"
+      )
+
+      assert_equal "claude_completion_fallback", record.fetch("event_type")
+      assert_includes record.fetch("message"), "level=warn"
+      status = File.read(File.join(dir, "status.md"))
+      assert_includes status, "Last event:    claude_completion_fallback"
+      assert_includes status, "Current agent: #{Hive::Events::EM_DASH}"
+      refute_includes status, "Last event:    error"
+    end
+  end
+
+  def test_completion_fallback_event_details_stay_within_message_bound
+    with_tmp_dir do |dir|
+      record = Hive::Events.emit(
+        task_folder: dir,
+        slug: "fallback-test",
+        stage: "6-review",
+        event_type: :claude_completion_fallback,
+        message: "level=warn details=#{"ø" * Hive::Events::MAX_MESSAGE_BYTES}"
+      )
+
+      assert_operator record.fetch("message").bytesize, :<=, Hive::Events::MAX_MESSAGE_BYTES
+      assert record.fetch("message").end_with?(Hive::Events::MESSAGE_TRUNCATION_SUFFIX)
+      JSON.parse(File.readlines(File.join(dir, "events.jsonl")).last)
+    end
+  end
+
+  def test_emit_rejects_a_short_append_instead_of_returning_in_memory_evidence
+    with_tmp_dir do |dir|
+      short_writer = Object.new
+      short_writer.define_singleton_method(:syswrite) { |line| line.bytesize - 1 }
+      original_open = File.method(:open)
+      open_calls = 0
+      open_file = lambda do |*_args, **_kwargs, &block|
+        open_calls += 1
+        if open_calls == 1
+          block.call(short_writer)
+        else
+          original_open.call(*_args, **_kwargs, &block)
+        end
+      end
+
+      record = nil
+      _out, err = capture_io do
+        with_replaced_singleton_method(File, :open, open_file) do
+          record = Hive::Events.emit(
+            task_folder: dir,
+            slug: "fallback-test",
+            stage: "6-review",
+            event_type: :claude_completion_fallback,
+            message: "level=warn"
+          )
+        end
+      end
+
+      assert_nil record
+      assert_match(/short append/, err)
+      refute_path_exists File.join(dir, "status.md")
+    end
+  end
+
   def test_unknown_event_type_raises
     with_tmp_dir do |dir|
       assert_raises(ArgumentError) do
